/* 
    =>>> look at error.h
*/

#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <unistd.h> /* sleep() */
#include "error.h"

int   vvv=3;
int   err_no=0,		/* stored last error */
      err_repeat=0,     /* last error repeated */
      err_fatal=0,      /* public, to inform calling functions */
      err_sum=0;        /* num of all errors, slowing down program */

/* sehr kurzes PG um auch in inneren schleifen wenig code zu erzeugen */
void err_pg(int no){
  int prt=1;
  if(no==-1){ errno=0; return; } /* reset errno */
  if(no==0 || no>=9000){
    if(err_no || err_repeat || err_fatal)
    printf("# error-status: err_no=%d err_repeat=%d err_fatal=%d\n",
            err_no,err_repeat,err_fatal);
    if(no==0)return;
  }
  if(err_no==no){ err_repeat++; }                   /* count errors */
  else          { err_repeat=0;err_no=no; }         /* reset counter */
  if (err_repeat > 100) { if (err_repeat%100) prt=0; } else  /* don't print */
  if (err_repeat >  10) { if (err_repeat%10 ) prt=0; }
  if (err_sum    > 100) { if (err_sum%100>10) prt=0; } /* don't print */
  if(no!=0 && prt!=0){
    printf("\nERROR code %4d (look at doc/error.tex for explanations)\n",no);
    printf(  "      repeated=%d num_errors=%d errno=%d\n",err_repeat-1,err_sum,errno);
    if (errno) 
    perror("PERROR");	/* output errno-code, man errno fmtmsg strerror oserror */
  }
  if(no>=9000){ /* system("ps -f"); */ /* show zombies or similar problems */
    exit(1); }
  /* avoid gigant error log-files (full disk) */
  if(no){ err_sum++;
    if (err_sum>1000) sleep(1);
    if (err_sum>10000) { printf(" sleep 10m");fflush(stdout);sleep(60*10); }
  } /* avoid big log files */
  return;
}

void err_pg_dbg(int no, int line, char *file){
  printf("\nDEBUG: %s L%d: ", file, line);
  err_pg(no);
  return;
}
